net.sourceforge.pmd.lang.java.dfa

## Class StatementAndBraceFinder

- java.lang.Object
- - net.sourceforge.pmd.lang.java.ast.JavaParserVisitorAdapter
  - - net.sourceforge.pmd.lang.java.dfa.StatementAndBraceFinder

All Implemented Interfaces:
  JavaParserVisitor

    public class StatementAndBraceFinder
    extends JavaParserVisitorAdapter

Author:
  raik

  Sublayer of DataFlowFacade. Finds all data flow nodes and stores the type information (@see StackObject). At last it uses this information to link the nodes.

### Constructor Summary

Constructors
Constructor and Description
`StatementAndBraceFinder(DataFlowHandler dataFlowHandler)`

### Method Summary

Methods
`void` `buildDataFlowFor(JavaNode node)`
`Object` `visit(ASTBreakStatement node, Object data)`
`Object` `visit(ASTContinueStatement node, Object data)`
`Object` `visit(ASTExpression node, Object data)`
`Object` `visit(ASTForInit node, Object data)`
`Object` `visit(ASTForUpdate node, Object data)`
`Object` `visit(ASTLabeledStatement node, Object data)`
`Object` `visit(ASTReturnStatement node, Object data)`
`Object` `visit(ASTStatementExpression node, Object data)`
`Object` `visit(ASTStatement node, Object data)`
`Object` `visit(ASTSwitchLabel node, Object data)`
`Object` `visit(ASTSwitchStatement node, Object data)`
`Object` `visit(ASTThrowStatement node, Object data)`
`Object` `visit(ASTVariableDeclarator node, Object data)`

### Methods inherited from class net.sourceforge.pmd.lang.java.ast.JavaParserVisitorAdapter

`visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### StatementAndBraceFinder

    public StatementAndBraceFinder(DataFlowHandler dataFlowHandler)

### Method Detail

#### buildDataFlowFor

    public void buildDataFlowFor(JavaNode node)

#### visit

    public Object visit(ASTStatementExpression node,
               Object data)

Specified by:
  `visit` in interface `JavaParserVisitor`
Overrides:
  `visit` in class `JavaParserVisitorAdapter`

#### visit

    public Object visit(ASTVariableDeclarator node,
               Object data)

Specified by:
  `visit` in interface `JavaParserVisitor`
Overrides:
  `visit` in class `JavaParserVisitorAdapter`

#### visit

    public Object visit(ASTExpression node,
               Object data)

Specified by:
  `visit` in interface `JavaParserVisitor`
Overrides:
  `visit` in class `JavaParserVisitorAdapter`

#### visit

    public Object visit(ASTForInit node,
               Object data)

Specified by:
  `visit` in interface `JavaParserVisitor`
Overrides:
  `visit` in class `JavaParserVisitorAdapter`

#### visit

    public Object visit(ASTLabeledStatement node,
               Object data)

Specified by:
  `visit` in interface `JavaParserVisitor`
Overrides:
  `visit` in class `JavaParserVisitorAdapter`

#### visit

    public Object visit(ASTForUpdate node,
               Object data)

Specified by:
  `visit` in interface `JavaParserVisitor`
Overrides:
  `visit` in class `JavaParserVisitorAdapter`

#### visit

    public Object visit(ASTStatement node,
               Object data)

Specified by:
  `visit` in interface `JavaParserVisitor`
Overrides:
  `visit` in class `JavaParserVisitorAdapter`

#### visit

    public Object visit(ASTSwitchStatement node,
               Object data)

Specified by:
  `visit` in interface `JavaParserVisitor`
Overrides:
  `visit` in class `JavaParserVisitorAdapter`

#### visit

    public Object visit(ASTSwitchLabel node,
               Object data)

Specified by:
  `visit` in interface `JavaParserVisitor`
Overrides:
  `visit` in class `JavaParserVisitorAdapter`

#### visit

    public Object visit(ASTBreakStatement node,
               Object data)

Specified by:
  `visit` in interface `JavaParserVisitor`
Overrides:
  `visit` in class `JavaParserVisitorAdapter`

#### visit

    public Object visit(ASTContinueStatement node,
               Object data)

Specified by:
  `visit` in interface `JavaParserVisitor`
Overrides:
  `visit` in class `JavaParserVisitorAdapter`

#### visit

    public Object visit(ASTReturnStatement node,
               Object data)

Specified by:
  `visit` in interface `JavaParserVisitor`
Overrides:
  `visit` in class `JavaParserVisitorAdapter`

#### visit

    public Object visit(ASTThrowStatement node,
               Object data)

Specified by:
  `visit` in interface `JavaParserVisitor`
Overrides:
  `visit` in class `JavaParserVisitorAdapter`